unit BS_IniIO;

interface

uses
 IniFiles , Forms , SysUtils , Graphics , Classes;

 procedure LoadIni    (IniPath  : String);
 procedure SaveIni    (IniPath  : String);
 procedure LoadNewPage();

implementation

uses
  BS_Main;

//------------------------------------------------------------------------------
procedure LoadIni(IniPath : String);
 var
  IniFile                                           : TIniFile;
  FS_Bold , FS_Italic , FS_UnderLine , FS_StrikeOut : Boolean;
  TmpFont                                           : TFont;
begin
  IniFile := TIniFile.Create(IniPath);
  TmpFont := TFont.Create();
  try
  try
    FS_Bold      :=          IniFile.ReadBool   ('Font' , 'Bold'      , False);
    FS_Italic    :=          IniFile.ReadBool   ('Font' , 'Italic'    , False);
    FS_UnderLine :=          IniFile.ReadBool   ('Font' , 'UnderLine' , False);
    FS_StrikeOut :=          IniFile.ReadBool   ('Font' , 'StrikeOut' , False);
    with TmpFont do  // etHgݒBoolɂĂۑ
    begin
      Name  :=               IniFile.ReadString ('Font' , 'Name'      , 'Terminal');
      Size  :=               IniFile.ReadInteger('Font' , 'Size'      , 13);
      Color := StringToColor(IniFile.ReadString ('Font' , 'Color'     , 'clWindowText'));
      Style := [];
      if (FS_Bold)      then  Style := Style + [fsBold];
      if (FS_Italic)    then  Style := Style + [fsItalic];
      if (FS_UnderLine) then  Style := Style + [fsUnderLine];
      if (FS_StrikeOut) then  Style := Style + [fsStrikeOut];
    end;
    with Form_Main do
    begin
     // ʌn
      Left                        := IniFile.ReadInteger('System' , 'Left '       , 0);
      Top                         := IniFile.ReadInteger('System' , 'Top'         , 0);
//    Width                       := IniFile.ReadInteger('System' , 'Width'       , 640);
//    Height                      := IniFile.ReadInteger('System' , 'Height'      , 480);
      OpenDialog.FileName         := IniFile.ReadString ('System' , 'Last Path'   , './');
      PageControl.ActivePageIndex := IniFile.ReadInteger('System' , 'Active Page' , 0);
      MItem_TaskTray.Checked      := IniFile.ReadBool   ('System' , 'Task-Tray'   , False);
      MItem_StayFront.Checked     := IniFile.ReadBool   ('System' , 'Stay Front'  , False);
      MItem_CloseCheck.Checked    := IniFile.ReadBool   ('System' , 'Close Check' , True);
      SpinEdit_Port.Value         := IniFile.ReadInteger('System' , 'Server Port' , 8799);
      FColumnDivStr               := IniFile.ReadString ('System' , 'Column Div'  , #9);
      PageControl.Font.Assign(TmpFont);
     // ŗLn
      if (IniFile.ReadBool('System' , 'Well Known Port' , False)) then SpinEdit_Port.MinValue := 0;
      if (ListView_Connect.Columns.Count > 5) then
      begin
        ListView_Connect.Column[0].Width := IniFile.ReadInteger('Column Width' , 'Player Name'  , 100);
        ListView_Connect.Column[1].Width := IniFile.ReadInteger('Column Width' , 'Player Type'  , 80);
        ListView_Connect.Column[2].Width := IniFile.ReadInteger('Column Width' , 'Host Name'    , 100);
        ListView_Connect.Column[3].Width := IniFile.ReadInteger('Column Width' , 'IP Address'   , 140);
        ListView_Connect.Column[4].Width := IniFile.ReadInteger('Column Width' , 'Port Number'  , 60);
        ListView_Connect.Column[5].Width := IniFile.ReadInteger('Column Width' , 'Connect Time' , 120);
      end;
      SpinEdit_FinalTurn.Value  := IniFile.ReadInteger('Game' , 'Final Turn'    , 50);
      Edit_GroupName.Text       := IniFile.ReadString ('Game' , 'Group Name'    , 'Tanaka Group');
      SpinEdit_UStkCost.Value   := IniFile.ReadInteger('Game' , 'Stock Cost'    , 1);
      SpinEdit_UBLCost.Value    := IniFile.ReadInteger('Game' , 'Back Log Cost' , 2);

      SpinEdit_MarcketMin.Value := IniFile.ReadInteger('Game' , 'Marcket Min' , 2);
      SpinEdit_MarcketMax.Value := IniFile.ReadInteger('Game' , 'Marcket Max' , 6);
      SpinEdit_FirstMin.Value   := IniFile.ReadInteger('Game' , 'First Min'   , 2);
      SpinEdit_FirstMax.Value   := IniFile.ReadInteger('Game' , 'First Max'   , 6);

      SpinEdit_FtOrder.Value    := IniFile.ReadInteger('Game' , 'Factory Order'    , 5);
      SpinEdit_W1Order.Value    := IniFile.ReadInteger('Game' , 'Whole1  Order'    , 5);
      SpinEdit_W2Order.Value    := IniFile.ReadInteger('Game' , 'Whole2  Order'    , 5);
      SpinEdit_RtOrder.Value    := IniFile.ReadInteger('Game' , 'Retail  Order'    , 5);
      SpinEdit_FtShipM.Value    := IniFile.ReadInteger('Game' , 'Factory Shipment' , 5);
      SpinEdit_W1ShipM.Value    := IniFile.ReadInteger('Game' , 'Whole1  Shipment' , 5);
      SpinEdit_W2ShipM.Value    := IniFile.ReadInteger('Game' , 'Whole2  Shipment' , 5);
      SpinEdit_RtShipM.Value    := IniFile.ReadInteger('Game' , 'Retail  Shipment' , 5);
    end;
  //LastDir := ExcludeTrailingBackSlash(StringReplace(IniFile.ReadString('System' , 'Last Directory' , '.') , '/' , '\' , [rfReplaceAll]));
  //Application.HintPause     := Round(IniFile.ReadFloat('System' , 'Before Hint' , 1) * 1000);
  //Application.HintHidePause := Round(IniFile.ReadFloat('System' , 'Hint Time'   , 5) * 1000);
  //LogoTime                  := Round(IniFile.ReadFloat('System' , 'Logo Time'   , 2) * 1000);
  finally
    TmpFont.Free();
    IniFile.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
procedure SaveIni(IniPath : String);
 var
  IniFile : TIniFile;
  TmpFont : TFont;
begin
  IniFile := TIniFile.Create(IniPath);
  TmpFont := TFont.Create();
  try
  try
    with Form_Main do
    begin
      IniFile.WriteInteger('System' , 'Left'        , Left);
      IniFile.WriteInteger('System' , 'Top'         , Top);
      IniFile.WriteInteger('System' , 'Width'       , Width);
      IniFile.WriteInteger('System' , 'Height'      , Height);
      IniFile.WriteString ('System' , 'Last Path'   , OpenDialog.FileName);
      IniFile.WriteInteger('System' , 'Active Page' , PageControl.ActivePageIndex);
      IniFile.WriteBool   ('System' , 'Task-Tray'   , MItem_TaskTray.Checked);
      IniFile.WriteBool   ('System' , 'Stay Front'  , MItem_StayFront.Checked);
      IniFile.WriteBool   ('System' , 'Close Check' , MItem_CloseCheck.Checked);
      TmpFont.Assign(PageControl.Font);
     // ŗLn
      IniFile.WriteInteger('System' , 'Server Port' , SpinEdit_Port.Value);
      if (ListView_Connect.Columns.Count > 5) then
      begin
        IniFile.WriteInteger('Column Width' , 'Player Name'  , ListView_Connect.Column[0].Width);
        IniFile.WriteInteger('Column Width' , 'Player Time'  , ListView_Connect.Column[1].Width);
        IniFile.WriteInteger('Column Width' , 'Host Name'    , ListView_Connect.Column[2].Width);
        IniFile.WriteInteger('Column Width' , 'IP Address'   , ListView_Connect.Column[3].Width);
        IniFile.WriteInteger('Column Width' , 'Port Number'  , ListView_Connect.Column[4].Width);
        IniFile.WriteInteger('Column Width' , 'Connect Time' , ListView_Connect.Column[5].Width);
      end;
      IniFile.WriteInteger('Game' , 'Final Turn'    , SpinEdit_FinalTurn.Value);
      IniFile.WriteString ('Game' , 'Group Name'    , Edit_GroupName.Text);
      IniFile.WriteInteger('Game' , 'Stock Cost'    , SpinEdit_UStkCost.Value);
      IniFile.WriteInteger('Game' , 'Back Log Cost' , SpinEdit_UBLCost.Value);

      IniFile.WriteInteger('Game' , 'Marcket Min'   , SpinEdit_MarcketMin.Value);
      IniFile.WriteInteger('Game' , 'Marcket Max'   , SpinEdit_MarcketMax.Value);
      IniFile.WriteInteger('Game' , 'First Min'     , SpinEdit_FirstMin.Value);
      IniFile.WriteInteger('Game' , 'First Max'     , SpinEdit_FirstMax.Value);

      IniFile.WriteInteger('Game' , 'Factory Order'    , SpinEdit_FtOrder.Value);
      IniFile.WriteInteger('Game' , 'Whole1  Order'    , SpinEdit_W1Order.Value);
      IniFile.WriteInteger('Game' , 'Whole2  Order'    , SpinEdit_W2Order.Value);
      IniFile.WriteInteger('Game' , 'Retail  Order'    , SpinEdit_RtOrder.Value);
      IniFile.WriteInteger('Game' , 'Factory Shipment' , SpinEdit_FtShipM.Value);
      IniFile.WriteInteger('Game' , 'Whole1  Shipment' , SpinEdit_W1ShipM.Value);
      IniFile.WriteInteger('Game' , 'Whole2  Shipment' , SpinEdit_W2ShipM.Value);
      IniFile.WriteInteger('Game' , 'Retail  Shipment' , SpinEdit_RtShipM.Value);
    end;
    IniFile.WriteString ('Font' , 'Name'      , TmpFont.Name);
    IniFile.WriteInteger('Font' , 'Size'      , TmpFont.Size);
    IniFile.WriteString ('Font' , 'Color'     , ColorToString(TmpFont.Color));
    IniFile.WriteBool   ('Font' , 'Bold'      , (fsBold      in TmpFont.Style));
    IniFile.WriteBool   ('Font' , 'Italic'    , (fsItalic    in TmpFont.Style));
    IniFile.WriteBool   ('Font' , 'UnderLine' , (fsUnderLine in TmpFont.Style));
    IniFile.WriteBool   ('Font' , 'StrikeOut' , (fsStrikeOut in TmpFont.Style));
  finally
    TmpFont.Free();
    IniFile.Free();
  end
  except
    raise;
  end;
end;


//------------------------------------------------------------------------------
//------------------ R}hCt@CI[v --------------------
procedure LoadNewPage();
 var
  i       : Integer;
  TmpList : TStringList;
begin
  TmpList := TStringList.Create();
  try
  try
    for i := 1 to ParamCount() do
    begin
      TmpList.Add(StringReplace(ParamStr(i) , '"' , '' , [rfReplaceAll]));
    end;
    if (TmpList.Count < 1) then Exit;
    for i := 0 to TmpList.Count - 1 do
    begin
      if (not FileExists(TmpList.Strings[i]))    then Continue;
//    if (not AskOpenBinary(TmpList.Strings[i])) then Continue; // oCi`FbN
    end;
  finally
    TmpList.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
end.
