unit Sub;

interface

uses
  Windows , Forms , Classes , SysUtils , Dialogs , ShellAPI , Graphics , WinSock;
type
  TMyByteArray = array of Byte;
  PMyByteArray = ^TMyByteArray;

  function  BinToStr      (Data : PMyByteArray; Header : Boolean = True)           : String; overload;
  procedure BinToStr      (Data : PMyByteArray; Dest   : TStrings; Header : Boolean = True); overload;
  function  GetMachineType() : String;
  function  IsBinary      (Path        : String) : Boolean;
  function  AskOpenBinary (Path        : String) : Boolean;
  function  GetHostAddress() : String;
  function  GetDomainName () : String;
  function  GetMACAddress () : String;
  function  ShowFontInfo  (Font : TFont) : String;

implementation

//------------------------------------------------------------------------------
//----------------------- oCi𕶎o͂ -----------------------------
function BinToStr(Data : PMyByteArray; Header : Boolean) : String;
 var
  TmpStrList : TStringList;
begin
  Result := '';
  TmpStrList := TStringList.Create();
  try
  try
    BinToStr(Data , TmpStrList , Header);
    Result := TmpStrList.Text;
  finally
    TmpStrList.Free();
  end
  except
  end;
end;

//------------------------------------------------------------------------------
procedure BinToStr(Data : PMyByteArray; Dest : TStrings; Header : Boolean);
 var
  i , j , DataLength , LineLength : Integer;
  LineBinStr                      : String;
begin
  if (Dest = Nil) then Exit;
  DataLength := Length(Data^);

 // Header
  if (Header) then Dest.Add('[OffSet] : +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F');

  j := 0;
  while (j < DataLength) do
  begin
   // ̍s̒擾(16ByteȂ΂̕)
    if ( (DataLength - j) > 16) then
      LineLength := 16
    else
      LineLength := DataLength - j;

    if (LineLength < 1) then Exit; // sb^IĂΏI

   // s̐l16i8
    if (Header) then  LineBinStr := IntToHex(j , 8) + ' : '
    else              LineBinStr := '';

   // ۂ̕񐶐(1s)
    for i := 0 to LineLength - 1 do
      LineBinStr := LineBinStr + IntToHex(Data^[j + i] , 2) + ' ';
    Dest.Add(TrimRight(LineBinStr));

   // 1sV[N
    Inc(j , LineLength);
  end;
end;


//------------------------------------------------------------------------------
function GetMachineType() : String;
begin
// [HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System]
// "Identifier"="NEC PC-98"
  case (GetKeyboardType(1)) of
    $0000..$0004 : Result := 'PC/AT Compatible';
    $0D01..$0D06 : Result := 'PC-9800 Series, Wonderful!';
    $0441..$0441 : Result := 'EPSON Note';
    else           Result := 'Unresolvable PC';
  end;
end;

//------------------------------------------------------------------------------
function IsBinary(Path : String) : Boolean;
 const
  CheckLength = 300; // Ƃ肠`FbNœǂݏo
 var
  i , Readed : integer;
  F          : File;
  Buf        : array[0..CheckLength] of Byte;
begin
  Result := True;
  if (not FileExists(Path)) then Exit;
  try
  try
    AssignFile(F , Path);
    Reset(F , 1);
    BlockRead(F , Buf , CheckLength , Readed); // 擪300oCgǂݍBufɂ
    if (Readed < 1) then Exit;
    Result := False;
    for i := 0 to Readed - 1 do
    begin
      case (Buf[i]) of  // ꂩoCi
        $00..$06 ,
        $0B..$0C ,
        $0E..$1F : begin Result := True;  Break; end;
        // 07̓A[A08̓obNXy[XA0A,0D͉sȂ̂ŃeLXg̉\^^;
      end;
    end;
  finally
    CloseFile(F);
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
function AskOpenBinary(Path : String) : Boolean;
 var
  ConfirmMsg : String;
begin
  Result := True;
  if (IsBinary(Path)) then
  begin    // TrueȂJ
    ConfirmMsg := '"' + Path + '"is possible to be a text file. Open?';
    Beep();   // LZꂽFalse
    if (MessageDlg(ConfirmMsg , mtConfirmation , [mbYes , mbCancel] , 1000) = idCancel) then  Result := False;
  //06/02/15  if (Application.MessageBox(ConfirmMsg,'Confirmation',mb_OKCancel) = idCancel) then  Result := False;
  end
end;

//------------------------------------------------------------------------------
function GetDomainName() : string;
 type
  TTokenUser = record
    User : TSIDAndAttributes;
  end;
  PTokenUser = ^TTokenUser;
var
  TokenHandle                    : THandle;
  TokenInfo                      : array[0..1023] of Byte;
  TokenUserInfo                  : PTokenUser;
  AccountName ,  DomainName      : array[0..255] of Char;
  Len , AccountSize , DomainSize : DWORD;
  Snu                            : SID_NAME_USE;
begin
  Result := '';
  if (not (OpenProcessToken(GetCurrentProcess , TOKEN_READ , TokenHandle))) then Exit;
  if (not (GetTokenInformation(TokenHandle , TokenUser , @TokenInfo , SizeOf(TokenInfo) , Len))) then
  begin
    CloseHandle(TokenHandle);
    Exit;
  end;
  CloseHandle(TokenHandle);

  TokenUserInfo := @TokenInfo;
  AccountSize   := SizeOf(AccountName);
  DomainSize    := SizeOf(DomainName);
  if (LookupAccountSid(nil , TokenUserInfo.User.Sid , AccountName , AccountSize ,
                       DomainName , DomainSize , Snu)) then
    Result := String(DomainName);
end;

//------------------------------------------------------------------------------
function GetHostAddress() : String;
 var
  WSAData  : TWsaData;
  HostName : array [0..255] of Char;
  Host     : PHostEnt;
  In_Addr  : TInAddr;
begin
  Result := '';
  WSAStartup($101 , WSAData);
  GetHostName(@HostName , SizeOf(HostName));
  Host     := GetHostByName(HostName);
  In_Addr  := PInAddr(PInAddr(Host^.h_addr_list)^)^;
  Result   := String(HostName) + ' [' + String(inet_ntoa(in_addr)) + ']';
  WSACleanup();
end;

//------------------------------------------------------------------------------
function GetMACAddress() : String;
 type
  TGuid = packed record
    Data1 : LongInt;
    Data2 : Word;
    Data3 : Word;
    Data4 : array [0..7] of Byte;
  end;
  TUuid      = TGuid;
  RPC_STATUS = LongInt;
 var
  DLLHnd  : THandle;
  i       : integer;
  UserID  : TUuid;
  TmpFunc : function(var UUID : TUuid) : RPC_STATUS; stdcall;
begin
  Result := '';
  DLLHnd := LoadLibrary('RPCRT4.dll');
 // DLL̃[hs͂Ȃ
  if (DLLHnd = 0) then Exit;

 // DLL̊֐[hs͂Ȃ
  TmpFunc := GetProcAddress(DLLHnd , 'UuidCreate');
  if (@TmpFunc = nil) then Exit;
 // UuidCreate֐s
  TmpFunc(UserID);
  for i := 2 to 7 do
  begin
    Result := Result + IntToHex(UserID.Data4[i] , 2);
    if (i < 7) then Result := Result + ':';
  end;
end;

//------------------------------------------------------------------------------
function ShowFontInfo(Font : TFont) : String;
 var
  StrList : TStringList;
begin
  Result := '';
  if (Font = NIl) then Exit;
  StrList := TStringList.Create();
  try
  try
    StrList.Add('Name@ : ' + Font.Name);
    StrList.Add('Color@: ' + ColorToString(Font.Color));
    StrList.Add('Height : ' + IntToStr(Font.Height));
    StrList.Add('Size@ : ' + IntToStr(Font.Size));
    StrList.Add('PPI@@: ' + IntToStr(Font.PixelsPerInch));
    StrList.Add('Handle : ' + '0x' + IntToHex(Font.Handle , 8) + 'h');
    Result := StrList.Text;
  finally
    StrList.Free();
  end
  except
    raise;
  end;
end;

//------------------------------------------------------------------------------
end.
